<?php
/*
Plugin Name: Go Live URL Update 
Plugin URI: https://www.bitbytez.net/
Description: This small plugin <strong>updates all urls in your website</strong> by replacing old urls with new urls. To get started: 1) Click the "Activate" link to the left of this description, and 2) Go to your <a href="tools.php?page=go-live-url-update.php">URL Update</a> page to use it.
Author: mafia99
Author URI: https://www.bitbytez.net
Author Email: muhammadalifayyaz@gmail.com
Version: 1.0
License: GPLv2 or later
Text Domain: go-live-url-update
*/

/*
Copyright 2016  Bitbytez.net

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
if ( !function_exists( 'add_action' ) ) { exit; 
}
function GoLiveUU_add_management_page(){
	add_management_page("Go Live URL Update", "URL Update", "manage_options", basename(__FILE__), "GoLiveUU_management_page");
}
function GoLiveUU_load_textdomain(){
	load_plugin_textdomain( 'go-live-url-update', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );
}
function GoLiveUU_management_page(){
	if ( !function_exists( 'GL_update_urls' ) ) {
		function GL_update_urls($options,$oldurl,$newurl){	
			global $wpdb;
			$results = array();
			$queries = array(
			'content' =>		array("UPDATE $wpdb->posts SET post_content = replace(post_content, %s, %s)",  __('Content Items (Posts, Pages, Custom Post Types, Revisions)','go-live-url-update') ),
			'excerpts' =>		array("UPDATE $wpdb->posts SET post_excerpt = replace(post_excerpt, %s, %s)", __('Excerpts','go-live-url-update') ),
			'attachments' =>	array("UPDATE $wpdb->posts SET guid = replace(guid, %s, %s) WHERE post_type = 'attachment'",  __('Attachments','go-live-url-update') ),
			'links' =>			array("UPDATE $wpdb->links SET link_url = replace(link_url, %s, %s)", __('Links','go-live-url-update') ),
			'custom' =>			array("UPDATE $wpdb->postmeta SET meta_value = replace(meta_value, %s, %s)",  __('Custom Fields','go-live-url-update') ),
			'guids' =>			array("UPDATE $wpdb->posts SET guid = replace(guid, %s, %s)",  __('GUIDs','go-live-url-update') )
			);
			foreach($options as $option){
				if( $option == 'custom' ){
					$n = 0;
					$row_count = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->postmeta" );
					$page_size = 10000;
					$pages = ceil( $row_count / $page_size );
					
					for( $page = 0; $page < $pages; $page++ ) {
						$current_row = 0;
						$start = $page * $page_size;
						$end = $start + $page_size;
						$pmquery = "SELECT * FROM $wpdb->postmeta WHERE meta_value <> ''";
						$items = $wpdb->get_results( $pmquery );
						foreach( $items as $item ){
						$value = $item->meta_value;
						if( trim($value) == '' )
							continue;
						
							$edited = GL_unserialize_replace( $oldurl, $newurl, $value );
						
							if( $edited != $value ){
								$fix = $wpdb->query("UPDATE $wpdb->postmeta SET meta_value = '".$edited."' WHERE meta_id = ".$item->meta_id );
								if( $fix )
									$n++;
							}
						}
					}
					$results[$option] = array($n, $queries[$option][1]);
				}
				else{
					$result = $wpdb->query( $wpdb->prepare( $queries[$option][0], $oldurl, $newurl) );
					$results[$option] = array($result, $queries[$option][1]);
				}
			}
			return $results;			
		}
	}
	if ( !function_exists( 'GL_unserialize_replace' ) ) {
		function GL_unserialize_replace( $from = '', $to = '', $data = '', $serialised = false ) {
			try {
				if ( false !== is_serialized( $data ) ) {
					$unserialized = unserialize( $data );
					$data = GL_unserialize_replace( $from, $to, $unserialized, true );
				}
				elseif ( is_array( $data ) ) {
					$_tmp = array( );
					foreach ( $data as $key => $value ) {
						$_tmp[ $key ] = GL_unserialize_replace( $from, $to, $value, false );
					}
					$data = $_tmp;
					unset( $_tmp );
				}
				else {
					if ( is_string( $data ) )
						$data = str_replace( $from, $to, $data );
				}
				if ( $serialised )
					return serialize( $data );
			} catch( Exception $error ) {
			}
			return $data;
		}
	}
	if ( isset( $_POST['GLUU_settings_submit'] ) && !check_admin_referer('GLUU_submit','GLUU_nonce')){
		if(isset($_POST['GLUU_oldurl']) && isset($_POST['GLUU_newurl'])){
			if(function_exists('esc_attr')){
				$gluu_oldurl = esc_attr(trim($_POST['GLUU_oldurl']));
				$gluu_newurl = esc_attr(trim($_POST['GLUU_newurl']));
			}else{
				$gluu_oldurl = attribute_escape(trim($_POST['GLUU_oldurl']));
				$gluu_newurl = attribute_escape(trim($_POST['GLUU_newurl']));
			}
		}
		echo '<div id="message" class="error fade"><p><strong>'.__('ERROR','go-live-url-update').' - '.__('Please try again.','go-live-url-update').'</strong></p></div>';
	}
	elseif( isset( $_POST['GLUU_settings_submit'] ) && !isset( $_POST['GLUU_update_links'] ) ){
		if(isset($_POST['GLUU_oldurl']) && isset($_POST['GLUU_newurl'])){
			if(function_exists('esc_attr')){
				$gluu_oldurl = esc_attr(trim($_POST['GLUU_oldurl']));
				$gluu_newurl = esc_attr(trim($_POST['GLUU_newurl']));
			}else{
				$gluu_oldurl = attribute_escape(trim($_POST['GLUU_oldurl']));
				$gluu_newurl = attribute_escape(trim($_POST['GLUU_newurl']));
			}
		}
		echo '<div id="message" class="error fade"><p><strong>'.__('ERROR','go-live-url-update').' - '.__('Your URLs have not been updated.','go-live-url-update').'</p></strong><p>'.__('Please select at least one checkbox.','go-live-url-update').'</p></div>';
	}
	elseif( isset( $_POST['GLUU_settings_submit'] ) ){
		$gluu_update_links = $_POST['GLUU_update_links'];
		if(isset($_POST['GLUU_oldurl']) && isset($_POST['GLUU_newurl'])){
			if(function_exists('esc_attr')){
				$gluu_oldurl = esc_attr(trim($_POST['GLUU_oldurl']));
				$gluu_newurl = esc_attr(trim($_POST['GLUU_newurl']));
			}else{
				$gluu_oldurl = attribute_escape(trim($_POST['GLUU_oldurl']));
				$gluu_newurl = attribute_escape(trim($_POST['GLUU_newurl']));
			}
		}
		if(($gluu_oldurl && $gluu_oldurl != 'http://www.oldurl.com' && trim($gluu_oldurl) != '') && ($gluu_newurl && $gluu_newurl != 'http://www.newurl.com' && trim($gluu_newurl) != '')){
			$results = GL_update_urls($gluu_update_links,$gluu_oldurl,$gluu_newurl);
			$empty = true;
			$emptystring = '<strong>'.__('Why do the results show 0 URLs updated?','go-live-url-update').'</strong><br/>'.__('This happens if a URL is incorrect OR if it is not found in the content. Check your URLs and try again.','go-live-url-update').'<br/><br/><strong>'.__('Want us to do it for you?','go-live-url-update').'</strong><br/>'.__('Contact us at','go-live-url-update').' <a href="mailto:info@velvetblues.com?subject=Move%20My%20WP%20Site">info@velvetblues.com</a>. '.__('We will backup your website and move it for $65 OR simply update your URLs for only $29.','go-live-url-update');

			$resultstring = '';
			foreach($results as $result){
				$empty = ($result[0] != 0 || $empty == false)? false : true;
				$resultstring .= '<br/><strong>'.$result[0].'</strong> '.$result[1];
			}
			
			if( $empty ):
			?>
<div id="message" class="error fade">
<table>
<tr>
	<td><p><strong>
			<?php _e('ERROR: Something may have gone wrong.','go-live-url-update'); ?>
			</strong><br/>
			<?php _e('Your URLs have not been updated.','go-live-url-update'); ?>
		</p>
		<?php
			else:
			?>
		<div id="message" class="updated fade">
			<table>
				<tr>
					<td><p><strong>
							<?php _e('Success! Your URLs have been updated.','go-live-url-update'); ?>
							</strong></p>
						<?php
			endif;
			?>
						<p><u>
							<?php _e('Results','go-live-url-update'); ?>
							</u><?php echo $resultstring; ?></p>
						<?php echo ($empty)? '<p>'.$emptystring.'</p>' : ''; ?></td>
					<td width="60"></td>
					<td align="center"></td>
				</tr>
			</table>
		</div>
		<?php
		}
		else{
			echo '<div id="message" class="error fade"><p><strong>'.__('ERROR','go-live-url-update').' - '.__('Your URLs have not been updated.','go-live-url-update').'</p></strong><p>'.__('Please enter values for both the old url and the new url.','go-live-url-update').'</p></div>';
		}
	}
?>
		<div class="wrap">
		<h2>Go Live URL Update</h2>
		<form method="post" action="tools.php?page=<?php echo basename(__FILE__); ?>">
			<?php wp_nonce_field('GLUU_submit','GLUU_nonce'); ?>
			<p><?php printf(__("After moving a website, %s lets you fix old URLs in content, excerpts, links, and custom fields.",'go-live-url-update'),'<strong>Update URLs</strong>'); ?></p>
			<p><strong>
				<?php _e('WE RECOMMEND THAT YOU BACKUP YOUR WEBSITE.','go-live-url-update'); ?>
				</strong><br/>
				<?php _e('You may need to restore it if incorrect URLs are entered in the fields below.','go-live-url-update'); ?>
			</p>
			<h3 style="margin-bottom:5px;">
				<?php _e('Step'); ?>
				1:
				<?php _e('Enter your URLs in the fields below','go-live-url-update'); ?>
			</h3>
			<table class="form-table">
				<tr valign="middle">
					<th scope="row" width="140" style="width:140px"><strong>
						<?php _e('Old URL','go-live-url-update'); ?>
						</strong><br/>
						<span class="description">
						<?php _e('Old WebSite Address','go-live-url-update'); ?>
						</span></th>
                                                <td><input name="GLUU_oldurl" type="text" id="GLUU_oldurl" value="<?php echo (isset($gluu_oldurl) && trim($gluu_oldurl) != '')? $gluu_oldurl : ''; ?>" style="width:450px;" placeholder="http://www.oldurl.com or http://localhost/wordpress"/></td>
				</tr>
				<tr valign="middle">
					<th scope="row" width="140" style="width:140px"><strong>
						<?php _e('New URL','go-live-url-update'); ?>
						</strong><br/>
						<span class="description">
						<?php _e('New WebSite Address','go-live-url-update'); ?>
						</span></th>
                                                <td><input name="GLUU_newurl" type="text" id="GLUU_newurl" value="<?php echo (isset($gluu_newurl) && trim($gluu_newurl) != '')? $gluu_newurl : ''; ?>" style="width:450px;" placeholder="http://www.newurl.com"/></td>
				</tr>
			</table>
			<br/>
			<h3 style="margin-bottom:5px;">
				<?php _e('Step'); ?>
				2:
				<?php _e('Choose which URLs should be updated','go-live-url-update'); ?>
			</h3>
			<table class="form-table">
				<tr>
					<td><p style="line-height:20px;">
							<input name="GLUU_update_links[]" type="checkbox" id="GLUU_update_true" value="content" checked="checked" />
							<label for="GLUU_update_true"><strong>
								<?php _e('URLs in page content','go-live-url-update'); ?>
								</strong> (
								<?php _e('posts, pages, custom post types, revisions','go-live-url-update'); ?>
								)</label>
							<br/>
							<input name="GLUU_update_links[]" type="checkbox" id="GLUU_update_true1" value="excerpts" />
							<label for="GLUU_update_true1"><strong>
								<?php _e('URLs in excerpts','go-live-url-update'); ?>
								</strong></label>
							<br/>
							<input name="GLUU_update_links[]" type="checkbox" id="GLUU_update_true2" value="links" />
							<label for="GLUU_update_true2"><strong>
								<?php _e('URLs in links','go-live-url-update'); ?>
								</strong></label>
							<br/>
							<input name="GLUU_update_links[]" type="checkbox" id="GLUU_update_true3" value="attachments" />
							<label for="GLUU_update_true3"><strong>
								<?php _e('URLs for attachments','go-live-url-update'); ?>
								</strong> (
								<?php _e('images, documents, general media','go-live-url-update'); ?>
								)</label>
							<br/>
							<input name="GLUU_update_links[]" type="checkbox" id="GLUU_update_true4" value="custom" />
							<label for="GLUU_update_true4"><strong>
								<?php _e('URLs in custom fields and meta boxes','go-live-url-update'); ?>
								</strong></label>
							<br/>
							<input name="GLUU_update_links[]" type="checkbox" id="GLUU_update_true5" value="guids" />
							<label for="GLUU_update_true5"><strong>
								<?php _e('Update ALL GUIDs','go-live-url-update'); ?>
								</strong> <span class="description" style="color:#f00;">
								<?php _e('GUIDs for posts should only be changed on development sites.','go-live-url-update'); ?>
								</span> <a href="http://codex.wordpress.org/Changing_The_Site_URL#Important_GUID_Note" target="_blank">
								<?php _e('Learn More.','go-live-url-update'); ?>
								</a></label>
						</p></td>
				</tr>
			</table>
			<p>
				<input class="button-primary" name="GLUU_settings_submit" value="<?php _e('Update URLs NOW','go-live-url-update'); ?>" type="submit" />
			</p>
		</form>
		<?php
}
add_action('admin_menu', 'GoLiveUU_add_management_page');
add_action('admin_init','GoLiveUU_load_textdomain');
?>
